
#ifndef _filter_h_
#define _filter_h_

const CHAR *csAREA    = "Area";
const CHAR *csMASK    = "Mask";
const CHAR *csCOMMAND = "Command";

struct BLOCK {
  CHAR *area;
  CHAR *mask;
  CHAR *comm;
  BLOCK(void) {
    area = mask = comm = NULL;
  }
  BLOCK(BLOCK *bl) {
    area = bl->area;
    mask = bl->mask;
    comm = bl->comm;
  }
  ~BLOCK(void) {
    clear();
  }
  void reset(void) {
    area = mask = comm = NULL;
  }
  void clear(void) {
    delete comm; comm = NULL;
    delete mask; mask = NULL;
    delete area; area = NULL;
  };
  void print(void) {
    printf("Area   : %s\n",area);
    printf("Mask   : %s\n",mask);
    printf("Command: %s\n",comm);
  }
};

struct CONFIG {
  BLOCK	 *block;
  CONFIG *next;
  CONFIG(BLOCK *bl = NULL) {
    block = (bl == NULL ? NULL : new BLOCK(bl));
    next = NULL;
  }
  ~CONFIG(void) {
    delete block;
    delete next;
  }
  CONFIG *add(BLOCK *bl) {
    if(!bl) return this;
    if(!block) {
      block  = new BLOCK(bl);
      next = NULL;
      return this;
    }
    else {
      CONFIG *ptr = this;
      while(ptr->next) {
        ptr = ptr->next;
      }
      ptr->next = new CONFIG(bl);
      return ptr->next;
    }
  }
  void print(void) {
    CONFIG *ptr = this;
    while(ptr) {
      if(ptr->block) ptr->block->print();
      ptr = ptr->next;
    }
  }
};

APIRET startPgm(const CHAR *command);

#endif // _filter_h_
