//
//  ࢨ 楤
//
#ifdef __OS2__
  #define INCL_DOSFILEMGR
  #define INCL_DOSMISC
#endif
#include "os2.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#ifdef __UNIX__
  #include <errno.h>

  #include <sys/types.h>
  #include <unistd.h>
  long filelength(int __handle)
  {
     off_t cur_pos=lseek(__handle,0,SEEK_CUR);
     off_t len=lseek(__handle,0,SEEK_END);
     lseek(__handle,cur_pos,SEEK_SET);
     return (long)len;
  };
#else
  #include <io.h>
#endif

#include "protot.h"

const CHAR *msgGetFile			= "GetFile";
const CHAR *CRLF			= "\n\r";
const CHAR *DELIMITER_FOR_CONFIG	= " \t=";

#define ERR_Ok				0
#define ERR_MY_ERR			1000
#define ERR_NotData			ERR_MY_ERR+1
#define ERR_StringNotFound		ERR_MY_ERR+5

const ULONG LEN_MESSAGE_BUFFER		= 4096;

#ifdef __UNIX__
  #define stricmp strcasecmp
#endif

signed min(unsigned a,unsigned b)
{
  return a<b ? a : b;
}

signed max(unsigned a,unsigned b)
{
  return a>b ? a : b;
}

inline INT comp(const CHAR *a,const CHAR *b)
{
  return !stricmp(a,b);
}

CHAR *setNewBuf(const CHAR *src,ULONG len)
{
  if(!len) len = strlen(src);
  CHAR *dest = new CHAR[len + 1];
  if(dest) {
    memmove(dest,src,len);
    dest[len] = 0;
  }
  return dest;
}

//
// 롨ࠥ  ப ⮪  㪠 ஬
//
CHAR *getToken(const CHAR *start,
	       const CHAR *end,
	       ULONG num)
{
  if(!start) return NULL;			//  
  CHAR *buf = setNewBuf(start,end-start);	// 뤥塞 
  CHAR *ptr = strtok(buf,DELIMITER_FOR_CONFIG);
  for(ULONG i=1;i<num;i++) {
    if(!ptr) break;
    ptr = strtok(NULL,DELIMITER_FOR_CONFIG);
  }
  if(ptr) {
    memmove(buf,ptr,strlen(ptr)+1);		// ६頥  砫 
    ptr = buf;					// ⥫  砫
  }
  else
    delete buf;                                 // 祣    㦥
  return ptr;					// 頥 㪠⥫
}

#ifdef __OS2__

APIRET getFile(const CHAR *name,
	       CHAR *&buf)
{
  HFILE         hf;		//  䠩
  ULONG         usAction;	//   䠩, ᫨ 
  APIRET	rc;		//  

  buf = NULL;			//  
  rc = DosOpen(name,
	       &hf,
	       &usAction,
	       0L,
	       0L,
	       OPEN_ACTION_FAIL_IF_NEW|         //  ⮫쪮 騩
	       OPEN_ACTION_OPEN_IF_EXISTS,	// , ᫨ 
	       OPEN_FLAGS_FAIL_ON_ERROR|	//  , ᫨ 訡
	       OPEN_FLAGS_SEQUENTIAL|		// ᫥⥫쭮 ⥭
	       OPEN_SHARE_DENYWRITE|		//   㣨 ᠬ
	       OPEN_ACCESS_READONLY,		// 쪮  ⥭
	       NULL);				// EA    㤥
  if(rc) {
    printError(msgGetFile,rc);
    return rc;
  }
  // 塞  䠩
  FILESTATUS3 *fStat = new FILESTATUS3;         //   祭 
  rc = DosQueryFileInfo(hf,			//  䠩
			FIL_STANDARD,		//  
			fStat,			// 㤠  ⢥
			sizeof(FILESTATUS3));	//  ⢥
  ULONG lenFile = fStat->cbFile;		// ࠭塞  䠩
  delete fStat;                                 //  㤠塞
  if(rc) {
    printError(msgGetFile,rc);
    DosClose(hf);
    return rc;
  }
  buf = new CHAR[lenFile+1];			//     \0   
  ULONG ulReaded;
  rc = DosRead(hf,				//  䠩
	       buf,				//   ⥭
	       lenFile,                         //  䠩
	       &ulReaded);			// 쪮  ⠭
  DosClose(hf);                                 //  뢠
  buf[lenFile] = 0;				//  
  if(rc) {
    printError(msgGetFile,rc);
    delete buf;
    buf = NULL;
  }
  return rc;
}

#else

APIRET getFile(const CHAR *name,
	       CHAR *&buf)
{
  APIRET rc = 0;
  FILE *hf;
  hf = fopen(name,"rb");
  buf = NULL;			//  
  if(!hf) {
    printError(msgGetFile,errno);
    return errno;
  }
  ULONG lenFile = filelength(fileno(hf));
  buf = new CHAR[lenFile+1L];			//     \0   
  if(!buf) {
    rc = 5;
    printError(msgGetFile,rc);
    return rc;
  }
  rc = fread(buf,lenFile,1,hf);
  fclose(hf);
  buf[lenFile] = 0;				//  
  if(rc!=1) {
    printError(msgGetFile,errno);
    delete buf;
    buf = NULL;
    return errno;
  }
  return 0;
}
#endif

#ifdef __OS2__

VOID printError(const CHAR *name,
		APIRET code,
		const CHAR *msgFileName,
		const CHAR **table,
		const ULONG cnTable)
{
  APIRET	rc;
  ULONG         cbMsg;
  CHAR		*buf = new CHAR[LEN_MESSAGE_BUFFER], *ptr;

  *buf = 0;

  ULONG		len = LEN_MESSAGE_BUFFER;	//   ᮮ饭
  if(name) {				// ᫨  
    strcat(buf,name);			// 塞 
    strcat(buf,": ");
  }
  ptr = strchr(buf,0);			// ⥫   
  len -= strlen(buf);			//  㬥蠥

  rc = DosGetMessage((CHAR **)table,
		     cnTable,
		     ptr,
		     len,
		     code,
		     msgFileName,
		     &cbMsg);
  if(rc) {
    printf("It is not possible to open a transaction file `%s`\nfor an error with the code : `%ld`\nAn error code : %ld\n",name,code,rc);
  }
  else {
    if(cbMsg>=len) cbMsg = len-1;
    ptr[cbMsg] = 0;
    printf(buf);
  }
  delete buf;
}

#else

VOID printError(const CHAR *name,
		APIRET code,
		const CHAR *,			// msgFileName,
		const CHAR **,			// table,
		const ULONG )			// cnTable)
{
  CHAR		*buf = new CHAR[LEN_MESSAGE_BUFFER], *ptr;

  *buf = 0;
  if(name) {				// ᫨  
    strcat(buf,name);			// 塞 
    strcat(buf,": ");
  }
  ptr = strchr(buf,0);			// ⥫   
  strcat(ptr,strerror(code));
  printf("%s\n",buf);
  delete buf;
}

#endif

APIRET getString(CHAR *&buf,
		 CHAR *&end,
		 const CHAR *comment)
{
  end = NULL;				//    ப
  if(!buf) return ERR_NotData;		// ᫨  , 室
  do {
    while(*buf&&*buf<=' ') buf++;	// ய ஡
    if(!*buf) return ERR_StringNotFound;//  
    while(*buf&&strchr(comment,*buf)) { // ᫨  ਩
      while(*buf&&!strchr(CRLF,*buf))
	buf++;				//   ப
      while(*buf&&strchr(CRLF,*buf))
	buf++;				// ய ᨬ  ப
      while(*buf&&*buf<=' ') buf++;	// ய ஡
    }
    CHAR *ptr = buf;			// 砫 ப !
    while(*ptr&&			//    
	  !strchr(CRLF,*ptr)&&		//    ப
	  !strchr(comment,*ptr)) ptr++; //   砫 
    if(*ptr&&ptr!=buf) {		// ᫨ ப  
      ptr--;				// 室  ।饬 ᨬ
      while(ptr!=buf&&*ptr <= ' ')
	ptr--;				//   ᨬ   <= ' '
    }
    end = ptr;				//     ப
  } while(buf==end);			//  ப , 塞
  if(!*buf) return ERR_StringNotFound;	//  ᪠
  if(*end) end++;			//   ᨬ ᫥  ப
  return ERR_Ok;			//   浪
}
