// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

/* ----- DIRFILE.C -----
 * Functions for file and directory processing */

#ifndef _UNIX_
#   include <direct.h>
#   include <io.h>
#   include <sys\stat.h>
#else
#   include <unistd.h>
#   include <utime.h>
#   include "posixdir.h"
#endif
#include <fcntl.h>
#include "general.h"

char *dirfull(
    char *subdir )
{
    char *buff = malloc(DIRLEN);
//    perror("\n-11-");
#ifndef _UNIX_
    if( LASTCHAR( subdir ) == SLASHC )                // for OS/2 _fullpath
        LASTCHAR( subdir ) = 0;
#endif
//    buff = realpath(subdir, buff);
    realpath(subdir, buff);
//    printf("%s %s\n\n", subdir, buff);
//    perror("\n-12-");
#ifndef _UNIX_ // ne nado v verhniy registr v unix eto raznye veschy
    strupr( 
#endif
//    strcpy( subdir, buff = _fullpath( NULL, subdir, 0 ) ) 
//    strcpy( subdir, buff = realpath(subdir, NULL) ) 

//    strcpy( subdir, buff = realpath(subdir, buff) )
    strcpy( subdir, buff )
#ifndef _UNIX_
        )
#endif
;
//    perror("\n-13-");
    free( buff );
    return strcat( subdir, SLASHS );
}

/* --- filefull ---
 * fullname = subdir + filename */

char *filefull (char *fullname, char *subdir, char *filename)
{
//#if defined(DOS)
//  return strcat(strcpy(fullname,subdir),filename);
//#else
  return strncat(strcpy(fullname,subdir),filename,PATHLEN-strlen(subdir)-1);
//#endif
}

/* --- copyfile ---
 * copies infile to directory subdir by 32K blocks
 * if file exists old attributes are saved */

void copyfile (char *infile, char *subdir)
{
  char *temp, indir[DIRLEN], tofile[PATHLEN];
  int sfile,dfile,readed;
  static void *pktbuf;
#ifdef _UNIX_
    struct stat st;
    struct utimbuf ut;
    int rc;
#else
  unsigned short date,time;     // _dos_getftime(), _dos_setftime()
#endif

  if ((temp = strrchr(infile, SLASHC)) != NULL)  // load indir if there's dir
  {                                           // in infile
    strncpy(indir,infile,temp-infile+1);
    indir[temp-infile+1] = 0;
  }
  else
     *indir = 0;                              // else indir = 0 (for dirfull)
  if (!strcmp(dirfull(indir),dirfull(subdir))) return; // copy to itself
  if (temp) filefull(tofile,subdir,temp+1);   // subdir + name of file
  else filefull(tofile,subdir,infile);        // subdir + infile
  if (!pktbuf)                                // the first call to copyfile
    if ((pktbuf = malloc(0x8000)) == NULL) errexit(3,"pktbuf");

//  if ((sfile = open(infile,O_RDONLY|O_BINARY)) == -1)
  if ((sfile = fopen( infile, "r" )) == -1)
     errexit(1,infile);
//  if ((dfile = open(tofile,O_WRONLY|O_BINARY|O_CREAT|O_TRUNC,S_IWRITE)) == -1)
  if ((dfile = fopen( tofile, "wt" )) == -1)
     errexit(1,tofile);    // truncate if exists, create for write if not
//  readed = read(sfile,pktbuf,0x8000);
  readed = fread(pktbuf,1,0x8000,sfile);
  while (readed)
  {
//    if (write(dfile,pktbuf,readed) < readed)
    if (fwrite(pktbuf,1,readed,dfile) < readed)
       errexit(0,"Bad writing. Disk full?");
//    readed = read(sfile,pktbuf,0x8000);
    readed = fread(pktbuf,1,0x8000,sfile);
  }
#ifdef _UNIX_
      rc = fstat( sfile , &st );      
      if( rc != -1 )
      {
        ut.modtime = st.st_mtime;
        ut.actime = st.st_atime;
//        __futime( dfile, &ut );
        utime( dfile, &ut );

      }
#else
  _dos_getftime(sfile,&date,&time);     // dest file should have the same date
  _dos_setftime(dfile,date,time);
#endif
//  close(dfile);
//  close(sfile);
  fclose(dfile);
  fclose(sfile);
}

/* --- movefile ---
 * moves infile to directory subdir
 * renames if possible
 * calls copyfile() if not */

void movefile (char *infile, char *subdir)
{
  char *temp, tofile[PATHLEN];

  dirfull(subdir);
  temp = strrchr(infile, SLASHC );
  if (temp) filefull(tofile,subdir,temp+1);   // subdir + name of file
  else filefull(tofile,subdir,infile);        // subdir + infile

  if (rename(infile,tofile) == -1)           // if rename to itself -- OK?
  {
    copyfile(infile,subdir);
    unlink(infile);
  }
}

int makexist        // 1 if subdir exists or has been created; 0 if error
    (char *subdir)
{
    char *p, tempdir[DIRLEN];
//    perror("\n-1-");
    strcat( strcpy( tempdir, dirfull( subdir ) ), "." );   // "c:\home\dir\."
//    strcpy( tempdir, dirfull( subdir ) );   // "c:\home\dir\"
//    perror("\n-2-");
//    printf("\n>>%s\n", tempdir);
    if (access(tempdir,F_OK) == 0) return 1;    // subdir already exists
//    perror("\n-3-");
//    printf("\n>>%s\n", subdir);
    do
    {
#ifndef _UNIX_
        p = strchr(tempdir,0);
        if (*(p-3) == ':') return 0;            // if "c:\." doesn't exist
        *(p-2) = 0;                             // "c:\home\dir"
#else
        p = strchr(tempdir,'.');
//    printf("\n><%X\n", *p, *tempdir);
        if ((p-1) == tempdir) return 0;         // if "/." doesn't exist
        *(p-1) = 0;                             // "/home/dir"
#endif
        p = strrchr(tempdir, SLASHC );
        *(p+1) = '.';
        *(p+2) = 0;                             // "c:\home\."
    }
    while (access(tempdir,F_OK) != 0);          // till existing parent dir
    strcpy(tempdir,subdir);                     // "c:\home\dir\"
//    printf("\n>>%s\n", tempdir);
    while (p = strchr(p+1, SLASHC ))                 
    {
        *p = 0;                                 // "c:\home\dir"
#ifdef _UNIX_        
        mkdir(tempdir, S_IRWXU|S_IRWXG|S_IRWXO);
#else
        mkdir(tempdir);
#endif
        *p = SLASHC;                              // "c:\home\dir\"
    }
    strcat(tempdir,".");                        // "c:\home\dir\."
    return (access(tempdir,F_OK) == 0);
}

int fileage             // how old is the file (in days); -1 if error
    (char *filename)
{
    struct stat buf;
    if (stat(filename,&buf) == -1) return -1;
    return difftime(time(NULL),buf.st_mtime)/(24*3600);
}
