// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

#include "general.h"

#define SNDX sizeof(struct Sndx)

static FILE *Fndx;
static int num_of_ndx;
static struct Sndx indupe;
static struct Sndx *Index;

void loadindex (void)
{
  long Fsize;
  if ((Fndx = fopen("filin.ndx","a+b")) == NULL) errexit(1,"filin.ndx");
  fseek(Fndx,0L,SEEK_END);
  if ((Fsize = ftell(Fndx)) != 0)
  {
    if ((Index = calloc(1,Fsize)) == NULL) errexit(3,"index");
    num_of_ndx = Fsize/SNDX;
    fseek(Fndx,0L,SEEK_SET);
    fread(Index,Fsize,1,Fndx);
    fseek(Fndx,0L,SEEK_END);
  }
}

struct Sarea *filelook (char *file)
{
  int i=0;
  for( ; i<num_of_ndx; i++ )
     if( !wildnicmp(file,Index[i].file,12) )
        return isarea(Index[i].area);
  return NULL;
}

int dupecheck (void)
{
  int i=0;
  strncpy(indupe.file,in.file,12);            // only 8.3 name
  strcpy(indupe.area,in.area);
  strcpy(indupe.crc,in.crc);
  for (;i<num_of_ndx;i++)
      if (!strcmp(indupe.file,Index[i].file)
         && !strcmp(indupe.area,Index[i].area)
         && !strcmp(indupe.crc,Index[i].crc))
            return 0;
  return 1;
}

void addindex (void)
{
  Index=realloc(Index,(++num_of_ndx)*SNDX);
  Index[num_of_ndx-1]=indupe;
  fwrite(&indupe,SNDX,1,Fndx);
}

void closeindex (void)
{
  fclose(Fndx);
  if (num_of_ndx>1000)
  {
    if ((Fndx=fopen("filin.ndx","wb"))==NULL) errexit(1,"filin.ndx");
    fwrite(&Index[num_of_ndx-1000],SNDX,1000,Fndx);
    fclose(Fndx);
  }
}